#!/bin/bash

printf "***** UI Position Adjustomatic *****\n"
echo "Enter column number (1 - X, 2 - Y, 3 - Width, 4 - Height): "
read column
echo "Enter operation (add, subtract, multiply, divide): "
read operation
echo "Enter number for use with operation: "
read number
echo "Enter line number for operation scope: "
read lines
echo "Apply operation BEFORE or AFTER line $lines? "
read prune
echo "Enter input file: "
read file

: '
column="2"
operation="multiply"
number="3"
lines="500"
prune="before"
file="mb_settings.menu"
'

rect1=$((column + 1))
rect2=$((column + 2))
date=`date '+%s'`
backup="$file".bak"$date"

read -p "Confirm: $operation column $column by $number for all coordinates $prune line $lines in $file? (y/n) " -n 1 -r
printf "\n"
if [[ $REPLY =~ ^[Yy]$ ]]
then
	if [ "${prune,,}" = "before" ]
	then
		case $operation in
			"add")
				mv $file $backup
				awk \
				-v rect1="$rect1" \
				-v rect2="$rect2" \
				-v number="$number" \
				-v lines="$lines" \
				'
				$1 == "rect" && FNR < lines {
					$rect1 = $rect1 + number
					#print column " " $2 " " $3 " " $4 " " $5
				}
				$1 == "setitemrect" && FNR < lines {
					$rect2 = $rect2 + number
					#print column2 " " $3 " " $4 " " $5 " " $6
				}
				{
					print
				}
				' $backup > $file
			;;
			"subtract")
				mv $file $backup
				awk \
				-v rect1="$rect1" \
				-v rect2="$rect2" \
				-v number="$number" \
				-v lines="$lines" \
				'
				$1 == "rect" && FNR < lines {
					$rect1 = $rect1 - number
					#print column " " $2 " " $3 " " $4 " " $5
				}
				$1 == "setitemrect" && FNR < lines {
					$rect2 = $rect2 - number
					#print column2 " " $3 " " $4 " " $5 " " $6
				}
				{
					print
				}
				' $backup > $file
			;;
			"multiply")
				mv $file $backup
				awk \
				-v rect1="$rect1" \
				-v rect2="$rect2" \
				-v number="$number" \
				-v lines="$lines" \
				'
				$1 == "rect" && FNR < lines {
					$rect1 = $rect1 * number
					#print column " " $2 " " $3 " " $4 " " $5
				}
				$1 == "setitemrect" && FNR < lines {
					$rect2 = $rect2 * number
					#print column2 " " $3 " " $4 " " $5 " " $6
				}
				{
					print
				}
				' $backup > $file
			;;
			"divide")
				mv $file $backup
				awk \
				-v rect1="$rect1" \
				-v rect2="$rect2" \
				-v number="$number" \
				-v lines="$lines" \
				'
				$1 == "rect" && FNR < lines {
					$rect1 = $rect1 / number
					#print column " " $2 " " $3 " " $4 " " $5
				}
				$1 == "setitemrect" && FNR < lines {
					$rect2 = $rect2 / number
					#print column2 " " $3 " " $4 " " $5 " " $6
				}
				{
					print
				}
				' $backup > $file
			;;
			*) printf "Bad input $operation\n"; exit
		esac
		# fix indent
		sed -i 's/^rect/\t\t\trect/gm' $file
		sed -i 's/^setitemrect/\t\t\t\tsetitemrect/gm' $file
		printf "Done\n"
	elif [ "${prune,,}" = "after" ]
	then
		case $operation in
			"add")
				mv $file $backup
				awk \
				-v rect1="$rect1" \
				-v rect2="$rect2" \
				-v number="$number" \
				-v lines="$lines" \
				'
				$1 == "rect" && FNR > lines {
					$rect1 = $rect1 + number
					#print column " " $2 " " $3 " " $4 " " $5
				}
				$1 == "setitemrect" && FNR > lines {
					$rect2 = $rect2 + number
					#print column2 " " $3 " " $4 " " $5 " " $6
				}
				{
					print
				}
				' $backup > $file
			;;
			"subtract")
				mv $file $backup
				awk \
				-v rect1="$rect1" \
				-v rect2="$rect2" \
				-v number="$number" \
				-v lines="$lines" \
				'
				$1 == "rect" && FNR > lines {
					$rect1 = $rect1 - number
					#print column " " $2 " " $3 " " $4 " " $5
				}
				$1 == "setitemrect" && FNR > lines {
					$rect2 = $rect2 - number
					#print column2 " " $3 " " $4 " " $5 " " $6
				}
				{
					print
				}
				' $backup > $file
			;;
			"multiply")
				mv $file $backup
				awk \
				-v rect1="$rect1" \
				-v rect2="$rect2" \
				-v number="$number" \
				-v lines="$lines" \
				'
				$1 == "rect" && FNR > lines {
					$rect1 = $rect1 * number
					#print column " " $2 " " $3 " " $4 " " $5
				}
				$1 == "setitemrect" && FNR > lines {
					$rect2 = $rect2 * number
					#print column2 " " $3 " " $4 " " $5 " " $6
				}
				{
					print
				}
				' $backup > $file
			;;
			"divide")
				mv $file $backup
				awk \
				-v rect1="$rect1" \
				-v rect2="$rect2" \
				-v number="$number" \
				-v lines="$lines" \
				'
				$1 == "rect" && FNR > lines {
					$rect1 = $rect1 / number
					#print column " " $2 " " $3 " " $4 " " $5
				}
				$1 == "setitemrect" && FNR > lines {
					$rect2 = $rect2 / number
					#print column2 " " $3 " " $4 " " $5 " " $6
				}
				{
					print
				}
				' $backup > $file
			;;
			*) printf "Bad input $operation\n"; exit
		esac
		# fix indent
		sed -i 's/^rect/\t\t\trect/gm' $file
		sed -i 's/^setitemrect/\t\t\t\tsetitemrect/gm' $file
		printf "Done\n"
	else
		printf "Bad input $prune\n"
	fi
else
	printf "Aborting\n"
fi
